<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/sel4/src/error.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>error.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../sel4/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../sel4/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../sel4/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">core</span>::{<span class="ident">fmt</span>, <span class="ident">mem</span>, <span class="ident">result</span>};

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::sys</span>;

<span class="kw">pub</span> <span class="kw">type</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">result::Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">Error</span><span class="op">&gt;</span>;

<span class="attribute">#[<span class="ident">repr</span>(<span class="ident">u32</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">Debug</span>, <span class="ident">Eq</span>, <span class="ident">PartialEq</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Error</span> {
    <span class="ident">InvalidArgument</span> <span class="op">=</span> <span class="ident">sys::seL4_Error_seL4_InvalidArgument</span>,
    <span class="ident">InvalidCapability</span> <span class="op">=</span> <span class="ident">sys::seL4_Error_seL4_InvalidCapability</span>,
    <span class="ident">IllegalOperation</span> <span class="op">=</span> <span class="ident">sys::seL4_Error_seL4_IllegalOperation</span>,
    <span class="ident">RangeError</span> <span class="op">=</span> <span class="ident">sys::seL4_Error_seL4_RangeError</span>,
    <span class="ident">AlignmentError</span> <span class="op">=</span> <span class="ident">sys::seL4_Error_seL4_AlignmentError</span>,
    <span class="ident">FailedLookup</span> <span class="op">=</span> <span class="ident">sys::seL4_Error_seL4_FailedLookup</span>,
    <span class="ident">TruncatedMessage</span> <span class="op">=</span> <span class="ident">sys::seL4_Error_seL4_TruncatedMessage</span>,
    <span class="ident">DeleteFirst</span> <span class="op">=</span> <span class="ident">sys::seL4_Error_seL4_DeleteFirst</span>,
    <span class="ident">RevokeFirst</span> <span class="op">=</span> <span class="ident">sys::seL4_Error_seL4_RevokeFirst</span>,
    <span class="ident">NotEnoughMemory</span> <span class="op">=</span> <span class="ident">sys::seL4_Error_seL4_NotEnoughMemory</span>,
}

<span class="kw">impl</span> <span class="ident">fmt::Display</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;seL4_Error: {:?}&quot;</span>, <span class="self">self</span>)
    }
}

<span class="kw">impl</span> <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">sys::seL4_Error</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">into</span>(<span class="self">self</span>) -&gt; <span class="ident">sys::seL4_Error</span> {
        <span class="self">self</span> <span class="kw">as</span> <span class="ident">sys::seL4_Error</span>
    }
}

<span class="kw">impl</span> <span class="ident">Error</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">unchecked</span>(<span class="ident">err</span>: <span class="ident">sys::seL4_Error</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">mem::transmute</span>(<span class="ident">err</span>) <span class="comment">// no reason to pattern match when err is returned from sys</span>
    }

    <span class="comment">// assumes ret \in seL4_Error</span>
    <span class="comment">// &#39;None&#39; implies seL4_NoError</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">from_ret</span>(<span class="ident">ret</span>: <span class="ident">sys::seL4_Error</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="ident">ret</span> {
            <span class="ident">sys::seL4_Error_seL4_NoError</span> =&gt; <span class="prelude-val">None</span>,
            <span class="ident">err</span> <span class="kw">if</span> <span class="ident">err</span> <span class="op">&lt;</span> <span class="ident">sys::seL4_Error_seL4_NumErrors</span> =&gt; <span class="prelude-val">Some</span>(<span class="kw">unsafe</span> { <span class="ident"><span class="self">Self</span>::unchecked</span>(<span class="ident">err</span>) }),
            <span class="kw">_</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;invalid seL4_Error: {}&quot;</span>, <span class="ident">ret</span>),
        }
    }

    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">wrap</span>(<span class="ident">ret</span>: <span class="ident">u32</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="ident"><span class="self">Self</span>::or</span>((), <span class="ident">ret</span>)
    }

    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">or</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>(<span class="ident">r</span>: <span class="ident">T</span>, <span class="ident">ret</span>: <span class="ident">u32</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="ident"><span class="self">Self</span>::from_ret</span>(<span class="ident">ret</span>) {
            <span class="prelude-val">None</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">r</span>),
            <span class="prelude-val">Some</span>(<span class="ident">err</span>) =&gt; <span class="prelude-val">Err</span>(<span class="ident">err</span>),
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="sel4" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>